Subject: Re: bug#53127: [PATCH RFC] Turning Rust/Cargo inputs into“regular” inputs?

From: Ludovic Courtès <[email-masked]>
Date: Tue, 11 Jan 2022 11:11:19 +0100

Liliana Marie Prikler <[email-masked]> skribis:

> Am Montag, dem 10.01.2022 um 09:58 +0100 schrieb Ludovic Courtès:
>> Hi!
>> 
>> Liliana Marie Prikler <[email-masked]> skribis:
>> 
>> > I suppose adding (package-source rust-cargo) to inputs to preserve
>> > the
>> > old meaning would not make much sense?
>> 
>> No because you need transitivity (that is, you need sources of the
>> dependencies, too).
>> 
>> > If so, what about having a source output and using (list `(,rust-
>> > cargo
>> > "source") ...)?
>> 
>> AFAICS it wouldn’t help solve the problems I mentioned.
> Even if it held the transitive sources?

Ah yes, that could work.

> The only other idea I have is somehow adapting maven-build-system's
> parent-poms, but I don't know how that'd look like implementation-wise.

I’m not familiar with this.

[...]

>> Yeah, we could change things incrementally if that helps.
>> 
>> However, given that ‘guix style’ can automate all the changes, I
>> think we could just as well change everything at once.  The good
>> thing is that it allows us that the strategy we choose actually works
>> at scale, in every case.
> Ahh, but what if we told ‘guix style’ to automate all the changes
> incrementally?  In other words, we'd tell it to detect cycles in inputs
> and only commit those changes that it can make without creating one. 
> That'd be similar to the new-style inputs change, which also aborts if
> even a single input can't be handled.

Hmm yes, maybe.  As a first step I’d like to see if we can get rid of
those cycles altogether (that seems to be the case at first sight) or if
it’s just not an option.

Thanks,
Ludo’.